/// CaveGame - A procedural 2D platformer sandbox.
/// Created by Josh O'Leary @ Redacted Software, 2020-2025
/// Contact: josh@redacted.cc
/// Contributors: william@redacted.cc maxi@redacted.cc
/// This work is dedicated to the public domain.

/// @file SceneManager.hpp
/// @desc A mixin class that implements management, running, and transition of scene objects. Only one scene is active at a given time.
/// @edit 1/28/2025
/// @auth Josh O'Leary

#pragma once

namespace CaveGame::Client
{
    class Scene;

    class SceneManager
    {
    public:
        void ChangeScene(Scene* new_scene);
        Scene* CurrentScene();
    protected:
        void UpdateSceneState(float elapsed);
    protected:
        Scene* next_scene = nullptr;
        Scene* current_scene = nullptr;
        Scene* prev_scene = nullptr;
    };
}