#include <Client/AssetService.hpp>
#include <Core/Explosion.hpp>
#include <JGL/JGL.h>


namespace CaveGame::Core {


    void Explosion::DrawFrame(const Texture* texture, const AABB2D& quad, const Vector2& pos, const Vector2& scale)
    {
        JGL::J2D::DrawPartialSprite(texture, pos, quad.minPoint, quad.maxPoint, rotation, {0.5f, 0.5f}, scale);
    }

    void Explosion::Draw() {
        if (!HasDetonated()) { return; }
        if (anim_timer >= 1.25f) { return; }

        float draw_radius = radius * 1.25f;

        auto* tex = Client::AssetService::Get()->explosion_sprite;

        Vector2 pos = position - (Vector2(draw_radius));
        Vector2 scale  {draw_radius/16.f, draw_radius/16.f};

        DrawFrame(tex, CurrentFrame(), pos, scale);

                /*if (anim_timer > (4.f / 5.f)) {
                    JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION4.minPoint, SP_EXPLOSION4.maxPoint, rotation, {0.5f,0.5f}, {draw_radius/16.f, draw_radius/16.f});
                } else if (anim_timer > (3.f / 5.f)) {
                    JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION3.minPoint, SP_EXPLOSION3.maxPoint, rotation, {0.5f, 0.5f}, {draw_radius/16.f, draw_radius/16.f});
                } else if (anim_timer > (2.f / 5.f)) {
                    JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION2.minPoint, SP_EXPLOSION2.maxPoint, rotation, {0.5f, 0.5f}, {draw_radius/16.f, draw_radius/16.f});
                } else if (anim_timer > (1.f / 5.f)) {
                    JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION1.minPoint, SP_EXPLOSION1.maxPoint, rotation, {0.5f, 0.5f}, {draw_radius/16.f, draw_radius/16.f});
                } else {
                    JGL::J2D::DrawPartialSprite(tex, position-(Vector2(draw_radius)), SP_EXPLOSION0.minPoint, SP_EXPLOSION0.maxPoint, rotation, {0.5f, 0.5f}, {draw_radius/16.f, draw_radius/16.f});
                }*/

                //JGL::J2D::End();
    }
}
