#include <Core/Player.hpp>
#include <Client/AssetService.hpp>
#include <Core/Entity.hpp>
#include <JGL/JGL.h>
#include <ReWindow/InputService.h>
#include <jstick.hpp>


// TODO: Move this shit to Client/Player.cpp
void CaveGame::Core::Player::Draw() {

    Direction dir = Direction::None;

    if (!facing_left)
        dir = Direction::Horizontal;


    AABB2D quad = Frame_Idle;

    // TODO: Work on conditions to make the player sprite not rapidly change to 'falling' when dropping 1-tall steps.
    if (!on_ground && ( airtime > 0.1f || Math::Abs(velocity.y) > 10.f ))
    {
        if (velocity.y < 0)
            quad = Frame_Ascend;
        else
            quad = Frame_Descend;
    } else if (walking) { // Math::Abs(velocity.x) > 2) {
        //float clamped_velocity = (Math::Clamp(Math::Abs(velocity.x) - 5.f, 0.f, 50.f) / 20.f);
        float walk_cycle = Math::Mod(anim_timer*2.5f, 1);

        if (walk_cycle > 2.f/3.f) {
            quad = Frame_Walk3;
        } else if (walk_cycle > 1.f / 3.f) {
            quad = Frame_Walk2;
        } else {
            quad = Frame_Walk1;
        }
    }

    // TODO: Utilize land quad when falling enough to take fall damage, player can't move for a half second.

    auto myAsset = Client::AssetService::Get()->GetTexture("player");
    JGL::J2D::DrawPartialSprite(myAsset.get(), RenderTopLeft(), quad.minPoint, {16, 24}, 0, {0,0}, {1,1}, Colors::White, dir);
    JGL::J2D::OutlineRect(Colors::Red, RenderTopLeft(), texture_center * 2.f);
    JGL::J2D::OutlineRect(Colors::Blue, TopLeft(), bounding_box);
    J2D::DrawString(Colors::White, std::format("vel: {},{}", Math::Round(velocity.x, 2), Math::Round(velocity.y, 2)), position.x, position.y-8, 8, 0.5f);
    J2D::DrawString(Colors::White, std::format("ct: {} cd: {}", coll_tests, coll_hits), position.x, position.y-16, 8, 0.5f);
}

void CaveGame::Core::Player::Update(float elapsed) {
    Humanoid::Update(elapsed);

    anim_timer += elapsed;
    walking = false;


    Vector2 dpad = jstick::GetDPadAxis();

    if (noclip) {
        if (InputService::IsKeyDown(Keys::A) || dpad.x <= -0.5f)
            Accelerate({-500*elapsed, 0});

        if (InputService::IsKeyDown(Keys::D) || dpad.x >= +0.5f)
            Accelerate({500*elapsed, 0});

        if (InputService::IsKeyDown(Keys::W) || dpad.y <= -0.5f)
            Accelerate({0, -500*elapsed});

        if (InputService::IsKeyDown(Keys::S) || dpad.y >= 0.5f)
            Accelerate({0, 500*elapsed});

        return;
    }

    if (InputService::IsKeyDown(Keys::A) || dpad.x <= -0.5f)
        WalkLeft(elapsed);

    if (InputService::IsKeyDown(Keys::D) || dpad.x >= +0.5f)
        WalkRight(elapsed);

    if (InputService::IsKeyDown(Keys::W) || dpad.y <= -0.5f)
        Jump(elapsed);




    //if (InputService::IsKeyDown(Keys::S))
    //Accelerate({0, -1});
}