#pragma once

#include <Color4.hpp>
#include <Colors.hpp>
#include <JJX/JSON.hpp>
#include <map>

namespace JsonConversions {
    using namespace JJX;

    /// Parses an RGBA color structure from a json value, which may be one of the following:
    /// \n * An array of 3 to 4 integers.
    /// \n * A hexadecimal color-code string.
    /// \n * A JSON object with 'r', 'g', 'b', and optional 'a' fields.
    /// @return A Color4 structure.
    Color4 parse_color(const json::value &v);


    /// Parses a vector of strings from a json value, which may one string, or a JSON array of strings.
    /// @return A vector containing the parsed strings, or an empty vector if the format is invalid.
    std::vector<std::string> parse_string_list(const json::value& v);

}