#pragma once


#include "ConcurrentQueue.hpp"

namespace CaveGame::Core
{

    enum PacketType : unsigned int
    {
        Ping = 0,
        PlrDamageTile, SrvDamageTile,
        PlrPlaceTile, SrvPlaceTile,
        PlrDamageWall, SrvDamageWall,
        PlrPlaceWall, SrvPlaceWall,
        PlrUseItem,
        OpenDoor, CloseDoor,
        PlaceFurniture, BreakFurniture,
        EntityPhysicsTic,
        ClientHandshake,
        ClientRequestSession,
        ClientConfirmSection,
        ClientLogout,
        ClientSendMsg,
        ClientAdminCommand,
        ClientThrowItem,

        SrvHandshakeResponse,
        SrvDownloadChunk,
        SrvChatMessage,
        SrvKick,
        SrvUpdateTile,
        SrvUpdateWall,
        SrvAcceptLogin,
        SrvRejectLogin,
        SrvSpawnEntity,
        SrvPeerJoin,
        SrvPeerLeft,
        SrvRemoveEntity,
        SrvTime,



    };

    class Packet
    {
    public:
        PacketType Type;

        virtual const void* onSend(std::size_t& size)
        {

        }
        virtual void onRecieve(const void* data, std::size_t size)
        {

        }
    };

    class NetMsg
    {
        Packet Payload;
        //IPAddress Target;
        //IPAddress Source;
    };

    class SharedNetworkSubsystem
    {
    public:
        std::atomic<bool> running;
        ConcurrentQueue<NetMsg> Outgoing;
        ConcurrentQueue<NetMsg> Incoming;
    };
}